﻿using System;
using System.Web.UI;

using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace WebApplication1 {
    public partial class _Default : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
            if (!Page.IsPostBack) {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                RectangleShape worldExtent = new RectangleShape(-180, 90, 180, -90);

                RectangleShape recShp = new RectangleShape(-123.33853, 50.28656, -121.59719, 48.97957);
                Map1.CurrentExtent = recShp;

                Map1.MapTools.OverlaySwitcher.Enabled = true;
                Map1.MapTools.MouseCoordinate.Enabled = true;

                ShapeFileFeatureSource.BuildIndexFile(MapPath(@"~\App_Data\Adminbndy4ca00.shp"), BuildIndexMode.DoNotRebuild);
                ShapeFileFeatureLayer shp = new ShapeFileFeatureLayer(MapPath(@"~\App_Data\Adminbndy4ca00.shp"));
                shp.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
                shp.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.StaticOverlay.Layers.Add(shp);

                InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageOffsetY = -25f;
                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageWidth = 21;
                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageHeight = 25;
                markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.CustomOverlays.Add(markerOverlay);
            }
        }

        protected void Button2_Click(object sender, EventArgs e) {
            InMemoryMarkerOverlay markerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
            markerOverlay.Features.Clear();
            for (var i = 0; i < 1000; i++) {
                markerOverlay.Features.Add(new Feature(-123 + (i * 0.05), 49.00 + (i * 0.05)));
            }
        }
    }
}
